# -*- R -*-
# $RCSfile: resultMethods.R,v $
# $Date: 2003/10/08 14:51:08 $
# $Revision: 1.1 $
# Copyright 2001, Timothy H. Keitt
# Licence: GPL
#

#
# Generic method to be subclassed for each implementation
#

dbGetResult <- function(result) UseMethod("dbGetResult")
#
# Return a data frame with results
#

dbClearResult <- function(result) UseMethod("dbClearResult")
#
# Free resources associated with result object
#

dbResultInfo <- function(result) UseMethod("dbResultInfo")
#
# Returns a list with result information, e.g., status
#

dbColumnInfo <- function(result) UseMethod("dbColumnInfo")
#
# Type information about each column is stored in successive
# rows of the output.
#


#
# Default methods
#

dbGetResult.default <- function(result) {

  stop("Invalid result class")

}

dbClearResult.default <- function(result) {

  stop("Invalid result object")

}

dbResultInfo.default <- function(result) {

  stop("Invalid result object")

}

dbColumnInfo.default <- function(result) {

  stop("Invalid result class")

}

print.Rdbi.result <- function(x, ...){
  # Commented out by JZ
  # print.Rdbi.result <- function(result){
  # Commented out by JZ
 # print.list.pairs(dbResultInfo(result))

  # Changed to this by JZ
  printListPairs(dbResultInfo(x))
}


